
//默认视频播放器
var videoPlayer;
//播放器线路
var videpType;
//视频id
var videoid;
//专题id
var entityId;
//zt_list表id
var list_id = '';
//
var videoName;
//年级科目 用于保存播放日志记录数据
var grade_name;
//视频类型 用于保存播放日志记录数据
var list_type;
//是否免费  用于保存播放日志记录数据
var is_free;
//用于保存播放日志记录数据
var groupType;

//视频参数信息
var duration = 0;
//视频总时长
var nowPlayTimes = 0;
//当前播放
var eventType = '';
//字符串类型；播放事件类型，仅当 name 为 play 时有值；取值范围如下：//start（开始播放）//playing（正在播放）//pause（播放暂停）//stop（播放停止）//complete（播放完成）
var videoURL = '';
//视频播放地址

//视频控制栏是否显示
var videoControlTypes = true;

//播放下一条视频
var menuType;
var playData;
var totalIndex;
var object_type;//判断是否国际班跳转过来
var ispublish;//名师体验
apiready = function() {
	//初始化播放器
	videoPlayer = api.require('videoPlayer');

	//显示进度提示框
	api.showFloatBox({
		iconPath : 'widget://image/loading_more.gif',
		duration : 3000
	});

	//获取播放器播放线路
	videpType = $api.getStorage('videType');
	if (videpType == undefined || videpType == '' || videpType == null) {
		videpType = 0;
	}
	//获取传递参数
	videoid = api.pageParam.sourceid;//用于获取视频地址
	entityId = api.pageParam.entityId;
	list_id = api.pageParam.list_id;
	grade_name = api.pageParam.grade_name;
	list_type = api.pageParam.list_type;
	is_free = api.pageParam.is_free;
	groupType = api.pageParam.groupType;
	menuType = api.pageParam.menuType;
	object_type = api.pageParam.object_type;//判断是否国际班跳转过来
	ispublish = api.pageParam.ispublish;//名师体验
	if(menuType && menuType.indexOf('tbdc') != -1){
		selAllVideo();
	}

	addUserPlayLog();
	//查询需要播放的视频videoid
	selvideo(videoid, 'open', '', is_free);

	//监听当前页面事件
	addEventListenerPlay();
	
	api.addEventListener({
        name:'closeCurWin'
    },function(ret,err){
    	api.closeWin();
    });
};

function addUserPlayLog(){
	//签到按钮控制
	var date = new Date().getDate();
	if($api.getStorage("date") != date) $api.setStorage("date",date);
	//签到按钮控制end
    	var u_code = $api.getStorage('uCode');
    	if(groupType ==null || groupType =='' || groupType ==undefined || groupType =='undefined'){
    		groupType = '';
    	}
    	api.ajax({
			url : logURL + 'playLogs',
			method : 'post',
			cache : false,
			timeout : 30,
			dataType : 'json',
			data : {
				values : {
					u_code:u_code,
					list_id:list_id,
					zhztinfoid:entityId,
					list_type:list_type,
					grade_name:grade_name,
					groupType:groupType,
					apk_type : apkType
				}
			},
			returnAll : false,
		}, function(ret, err) {
			if(ret){
				if(ret.code=='200'){
					console.log('记录成功=='+ret.msg);
				}
			}
		});    
    }

//查询视频信息
function selvideo(videoid, type, videoName, is_free) {
	if (list_id == null || list_id == '' || list_id == undefined || list_id == 'undefined') {
		list_id = '';
	}
	var url = playURL + videoid;
	if(is_free==0) url = playURL + 'v2/' + videoid;
	api.ajax({
		url : url,
		method : 'post',
		cache : false,
		timeout : 30,
		dataType : 'json',
		data : {
			values : {
				list_id : list_id
			}
		},
		returnAll : false
	}, function(ret, err) {
		if (ret) {
			videoURL = ret.qcloud_video_url_05;
			//
			videoName = ret.source_video_name;
			//var video_name=ret.source_video_name;
			if (type == 'open') {
				if (videpType == 1) {//打开播放器（不可编辑样式播放器）
					fnvideoPlayerPlay(videoURL, videoName);
				}else {//打开播放器（可编辑样式播放器）
					fnvideoPlayerOpen(videoURL, videoName);
				}
			}
			if (type == 'notopen') {
				setPath(videoURL);
				$api.html($api.byId('title'), videoName);
			}
		} else {
			api.toast({
				msg : err.msg,
				duration : 3000,
				global : true
			});
			//console.log(JSON.stringify(err))
		}

	});
}

//调用普通视频播放器（可编辑播放器）
function fnvideoPlayerOpen(videoURL, videoName) {
	videoPlayer.open({
		rect : {
			x : 0, //（可选项）数字类型；模块左上角的 x 坐标（相对于所属的 Window 或 Frame）；默认：0
			y : 0, //（可选项）数字类型；模块左上角的 y 坐标（相对于所属的 Window 或 Frame）；默认：0
			w : api.winWidth, //（可选项）数字类型；模块的宽度；默认：所属的 Window 或 Frame 的宽度
			h : api.winHeight //（可选项）数字类型；模块的高度；默认：w的3/4
		},
		bg : '#fff', //视频背景颜色，支持#、rgb、rgba (在切换视屏为了防止闪屏,请根据自己的视频调节颜色)
		path : videoURL, //视频播放地址
		autoPlay : true, //打开时是否自动播放
		scalingMode : 'scaleToFill', //该参数仅支持ios
	}, function(ret, err) {
		if (ret.status) {
			//alert(JSON.stringify(ret));
			//获取视频总时长
			if (ret.duration != '' && ret.duration != null && ret.duration != 'undefined') {
				duration = JSON.stringify(ret.duration).replace(/\"/g, "");
			}
			//默认5s之后自动隐藏控制栏
			showControl();

			//打开自定义播放器样式
			openVideoTool(videoName);
			openVideoController();

			//监听播放器事件
			videoPlayerAddEventListener();
		} else {
			//alert(JSON.stringify(err));
			api.toast({
				msg : err.msg,
				duration : 2000,
				location : 'middle'
			});
		}
	});
}

//调用普通视频播放器（不可编辑播放器）
function fnvideoPlayerPlay(videoURL, videoName) {
	videoPlayer.play({
		texts : {
			head : {
				title : "视频" //视频名称
			}
		},
		styles : {//播放默认样式效果
			head : {
				bg : 'rgba(0,0,0,0.7)',
				height : 44,
				titleSize : 20,
				titleColor : '#fff',
				backSize : 30,
				backImg : 'widget://image/videoPlayer/back.png',
				setSize : 0,
				setImg : 'widget://image/videoPlayer/more.png'
			},
			foot : {
				bg : 'rgba(0,0,0,0.7)',
				height : 44,
				playSize : 30,
				playImg : 'widget://image/videoPlayer/play.png',
				pauseImg : 'widget://image/videoPlayer/pause.png',
				nextSize : 0,
				nextImg : '',
				timeSize : 14,
				timeColor : '#fff',
				sliderImg : '',
				progressColor : '#696969',
				progressSelected : '#1296db',
				verticalImg : "widget://image/videoPlayer/unfullscreen.png",
				horizontalImg : "widget://image/videoPlayer/fullscreen.png"
			}
		},
		path : videoURL, //播放地址
		autoPlay : true //是否自动播放
	}, function(ret, err) {
		if (ret) {
			if (JSON.stringify(ret.eventType).replace(/\"/g, "").replace(/[\\]/g, '') == 'back') {//返回
				backWin();
			} else if (JSON.stringify(ret.eventType).replace(/\"/g, "").replace(/[\\]/g, '') == 'failed') {
				//alert('播放失败')
			}
		} else {
			//alert(JSON.stringify(err));
		}
	});
}


//打开自定义播放器样式
function openVideoController() {
	api.openFrame({
		name : 'video_foot_01',
		url : '../videoPlayer/video_foot_01.html',
		bounces : false,
		rect : {
			x : 0,
			y : api.winHeight - 50,
			w : 'auto',
			h : 50
		},
		reload : true,
		slidBackEnabled : false,
		pageParam : {
			duration : duration,
			menuType :  menuType
		}
	});
}

function openVideoTool(videoName) {
	api.openFrame({
		name : 'video_head_01',
		url : '../videoPlayer/video_head_01.html',
		bounces : false,
		rect : {
			x : 0,
			y : 0,
			w : 'auto',
			h : 50
		},
		reload : true,
		slidBackEnabled : false,
		pageParam : {
			videoName : ''
		}
	});
}

//设置视频播放时间
function seekToPlay(times) {
	if (eventType && eventType.replace(/\"/g, "") == 'complete') {
		//videoPlayer.seekTo({seconds: 0});
		videoPlayer.setPath({
			path : videoURL
		});
	}
	videoPlayer.seekTo({
		seconds : times
	});
	videoPlayerAddEventListener();
}

function selAllVideo(){
	var pageSize = 100;
	api.ajax({
		url : ztGroupURL + '/course/' + entityId + '/' + 1 + '?pageSize=' + pageSize,
		method : 'post',
		cache : false,
		timeout : 30,
		dataType : 'json',
		data : {},
		returnAll : false,
	}, function(ret, err) {
		if (ret) {
			playData =  ret.result;	
			totalIndex = playData.length;
		} else {
			//console.log('获取课程列表失败')
		}

	});
}

//设置播放器播放视频地址
function setPath(videoPath) {
	videoPlayer.setPath({
		path : videoPath
	});
}

//视频播放器监听事件
function videoPlayerAddEventListener() {
	videoPlayer.addEventListener({
		name : 'leftUp'
	}, function(ret, err) {
		if (ret) {
			//alert(JSON.stringify(ret));
		} else {
			//alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'leftDown'
	}, function(ret, err) {
		if (ret) {
			//alert(JSON.stringify(ret));
		} else {
			//alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'rightUp'
	}, function(ret, err) {
		if (ret) {
			//alert(JSON.stringify(ret));
		} else {
			//alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'rightDown'
	}, function(ret, err) {
		if (ret) {
			// alert(JSON.stringify(ret));
		} else {
			// alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'swipeLeft'
	}, function(ret, err) {
		if (ret) {
			// alert(JSON.stringify(ret));
		} else {
			//alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'swipeRight'
	}, function(ret, err) {
		if (ret) {
			// alert(JSON.stringify(ret));
		} else {
			//alert(JSON.stringify(err));
		}
	});

	//屏幕点击事件
	videoPlayer.addEventListener({
		name : 'click'
	}, function(ret, err) {
		if (ret) {
			//点击显示隐藏
			window.clearTimeout(set);
			if (videoControlTypes) {
				hideControl();
			} else {
				showControl();
			}

		} else {
			//alert(JSON.stringify(err));
		}
	});

	videoPlayer.addEventListener({
		name : 'play'
	}, function(ret, err) {
		if (ret) {
			nowPlayTimes = JSON.stringify(ret.current);
			eventType = JSON.stringify(ret.eventType);
			if ('complete' == eventType.replace(/\"/g, "")) {
				api.removeEventListener({
					name : 'playType'
				});
				api.sendEvent({
					name : 'playType',
					extra : {
						eventType : eventType
					}
				});
			} else if ('playing' == eventType.replace(/\"/g, "")) {
				api.sendEvent({
					name : 'playType',
					extra : {
						nowPlayTimes : nowPlayTimes,
						eventType : eventType
					}
				});
			}

		} else {
			//alert(JSON.stringify(err));
		}
	});

}



//视频播放
function videoPlay() {
	videoPlayer.start();
}

//视频暂停
function videoPause() {
	videoPlayer.pause();
}

//视频全屏
function fullScreen() {
	videoPlayer.fullScreen();
	var winWidth = api.winWidth;
	var winHeight = api.winHeight;
	var w;
	var h;
	if (winWidth > winHeight) {
		w = winWidth;
		h = winHeight;
	} else {
		w = winHeight;
		h = winWidth;
	}
	videoPlayer.setRect({
		rect : {
			x : 0, //（可选项）数字类型；模块左上角的 x 坐标（相对于所属的 Window 或 Frame）；默认：0
			y : 0, //（可选项）数字类型；模块左上角的 y 坐标（相对于所属的 Window 或 Frame）；默认：0
			w : w, //（可选项）数字类型；模块的宽度；默认：所属的 Window 或 Frame 的宽度
			h : h //（可选项）数字类型；模块的高度；默认：w的3/4
		},
		fullscreen : true
	});
	api.setFrameAttr({
		name : 'video_foot_01',
		rect : {
			x : 0,
			y : h - 50,
			w : w,
			h : 50
		},
	});
}

//视频非全屏
function unfullScreen() {
	videoPlayer.cancelFullScreen();
	var winWidth = api.winWidth;
	var winHeight = api.winHeight;
	var w;
	var h;
	if (winWidth > winHeight) {
		w = winHeight;
		h = winWidth;
	} else {
		w = winWidth;
		h = winHeight;
	}
	videoPlayer.setRect({
		rect : {
			x : 0, //（可选项）数字类型；模块左上角的 x 坐标（相对于所属的 Window 或 Frame）；默认：0
			y : 0, //（可选项）数字类型；模块左上角的 y 坐标（相对于所属的 Window 或 Frame）；默认：0
			w : w, //（可选项）数字类型；模块的宽度；默认：所属的 Window 或 Frame 的宽度
			h : w * 0.75 //（可选项）数字类型；模块的高度；默认：w的3/4
		},
		fullscreen : false
	});
	api.setFrameAttr({
		name : 'video_foot_01',
		rect : {
			x : 0,
			y : w * 0.75 - 50,
			w : w,
			h : 50
		},
	});
}

var set;
function hideControl() {
	videoControlTypes = false;
	api.sendEvent({
		name : 'videoControl',
		extra : {
			videoControlType : 0,
			videoHeadType:0
		}
	});
}

function showControl() {
	videoControlTypes = true;
	api.sendEvent({
		name : 'videoControl',
		extra : {
			videoControlType : 1,
			videoHeadType:1
		}
	});
	//
	window.clearTimeout(set);
	set = window.setTimeout(function() {
		hideControl();
	}, 5000);
}

//监听当前页面事件
function addEventListenerPlay() {
	//安卓返回键
	androidKeyBack();
}

//安卓返回键
function androidKeyBack() {
	api.addEventListener({
		name : 'keyback'
	}, function(ret, err) {
		if(object_type != '' || object_type != null || object_type != undefined){
			api.sendEvent({
		        name:'openVedio'
	        });
		}
		api.closeWin();
	});
}